#include <bits/stdc++.h>

using namespace std;

// To store segment tree
int *st;

// Function to find gcd of 2 numbers.
int gcd(int a, int b)
{
    if (a < b)
        swap(a, b);
    if (b==0)
        return a;
    return gcd(b, a%b);
}

/*  A recursive function to get gcd of given
    range of array indexes. The following are parameters for
    this function.

    st    --> Pointer to segment tree
    si --> Index of current node in the segment tree. Initially
               0 is passed as root is always at index 0
    ss & se  --> Starting and ending indexes of the segment
                 represented by current node, i.e., st[index]
    qs & qe  --> Starting and ending indexes of query range */
int findGcd(int ss, int se, int qs, int qe, int si)
{
    if (ss>qe || se < qs)
        return 0;
    if (qs<=ss && qe>=se)
        return st[si];
    int mid = ss+(se-ss)/2;
    return gcd(findGcd(ss, mid, qs, qe, si*2+1),
               findGcd(mid+1, se, qs, qe, si*2+2));
}

//Finding The gcd of given Range
int findRangeGcd(int ss, int se, int arr[],int n)
{
    if (ss<0 || se > n-1 || ss>se)
    {
        cout << "Invalid Arguments" << "\n";
        return -1;
    }
    return findGcd(0, n-1, ss, se, 0);
}

// A recursive function that constructs Segment Tree for
// array[ss..se]. si is index of current node in segment
// tree st
int constructST(int arr[], int ss, int se, int si)
{
    if (ss==se)
    {
        st[si] = arr[ss];
        return st[si];
    }
    int mid = ss+(se-ss)/2;
    st[si] = gcd(constructST(arr, ss, mid, si*2+1),
                 constructST(arr, mid+1, se, si*2+2));
    return st[si];
}

/* Function to construct segment tree from given array.
   This function allocates memory for segment tree and
   calls constructSTUtil() to fill the allocated memory */
int *constructSegmentTree(int arr[], int n)
{
   int height = (int)(ceil(log2(n)));
   int size = 2*(int)pow(2, height)-1;
   st = new int[size];
   constructST(arr, 0, n-1, 0);
   return st;
}

const int MAX = 200000;
const int TREE_SIZE = 262143;

int n;
int values[MAX];

int dummy(int idxL, int idxR) {
    int res = values[idxL];
    for (int i = idxL + 1; i <= idxR; i++)
        res = min(res, values[i]);
    return res;
}

int tree[TREE_SIZE];

void update(int idx, int value) {
    idx += (TREE_SIZE >> 1);
    tree[idx] = value;
    for (idx = idx >> 1; idx > 0; idx >>= 1)
        tree[idx] = min(tree[(idx << 1) + 0], tree[(idx << 1) + 1]);
}

int query(int left, int right) {
    int idxL = left + (TREE_SIZE >> 1);
    int idxR = right + (TREE_SIZE >> 1);

    int res = min(tree[idxL], tree[idxR]);
    while (idxL + 1 < idxR) {
        if ((idxL & 1) == 0) res = min(res, tree[idxL ^ 1]);
        if ((idxR & 1) == 1) res = min(res, tree[idxR ^ 1]);
        idxL >>= 1, idxR >>= 1;
    }
    return res;
}

void buildTree(int* values, int valueCount) {
    memset(tree, 63, sizeof(tree)); // Initializes with a value > 1,000,000,000
    for (int i = 0; i < valueCount; i++)
        tree[i + (TREE_SIZE >> 1)] = values[i];
    for (int node = (TREE_SIZE >> 1) - 1; node > 0; node--)
        tree[node] = min(tree[(node << 1) + 0], tree[(node << 1) + 1]);
}

vector<int> v[1024];

int bs(int x,vector<int> v)
{
    int l=0,r=v.size()-1;
    int mid;
    while(l<=r)
    {
        mid=(l+r)/2;
        if(v[mid]==x) return mid;
        if(v[mid]>x) r=mid-1;
        else l=mid+1;
    }
    while(mid>-1&&v[mid]>x) mid--;
    if(mid<0) mid=0;
    if(v[mid]>x) mid=-1;
    return mid;
}

int bs2(int x,vector<int> v)
{
    int sz=v.size();
    int l=0,r=sz-1;
    int mid;
    while(l<=r)
    {
        mid=(l+r)/2;
        if(v[mid]==x) return mid;
        if(v[mid]>x) r=mid-1;
        else l=mid+1;
    }
    while(mid<sz&&v[mid]<x) mid++;
    if(mid>=sz) mid=sz-1;
    if(v[mid]<x) mid=sz;
    return mid;
}

int num(int a,int l,int r,int arr[])
{
    int ind1=bs(l,v[a]),ind2=bs2(r,v[a]);
    //cout<<" ---- "<<ind1<<" "<<ind2<<endl;
    return ind2-ind1+1;
    /*int br=0;
    for(int i=l;i<=r;i++) br+=a==arr[i];
    return br;*/
}

void buildVecs(int arr[], int n)
{
    for(int i=0;i<n;i++)
    {
        v[arr[i]].push_back(i);
    }
}

int main()
{
    cin>>n;
    for(int i=0;i<n;i++) cin>>values[i];
    buildTree(values,n);
    buildVecs(values,n);
    constructSegmentTree(values,n);
    /*for(int i1=0;i1<n;i1++)
    {
        for(int i2=i1;i2<n;i2++)
            query(i1,i2);
    }*/
    int qry;
    cin>>qry;
    for (int i=0;i<qry;i++)
    {
        int a,b;
        cin>>a>>b; --a; --b; int asd=query(a,b);
        cout<<asd<<" "<<num(asd,a,b,values)<<" "<<findRangeGcd(a,b,values,n)<<endl;
    }
    return 0;
}
